#include"Image.h"

#include<stdio.h>
#include<algorithm>
#include<string>
#include<vector>
#include<math.h>
#include<assert.h>
#include<random>

using namespace std;
using lf = double;

using namespace IMAGE;

struct vec2 {
	lf x, y;
	vec2() {
		x = y = 0;
	}
	vec2(lf x, lf y):x(x),y(y) {}

	vec2 operator +(const vec2& z) {
		return vec2(x + z.x, y + z.y);
	}
	vec2 operator -(const vec2& z) {
		return vec2(x - z.x, y - z.y);
	}
	vec2 operator *(const lf& z) {
		return vec2(x * z, y * z);
	}
	lf operator *(const vec2& z) {
		return x * z.x + y * z.y;
	}
	lf operator %(const vec2& z) {
		return x * z.y - y * z.x;
	}
	void normalize() {
		lf dd = sqrt(x * x + y * y);
		x /= dd;
		y /= dd;
	}
};
Image img;
Image imagejojic;
Image number[10];
Image imagejusagi;
int width = 480;
int height = 480;
lf padding = 20;
lf numscale = 0.7;
lf border_scale = 0.07;
Image jojics[4][4];

mt19937 rnd;
int nextint(int s, int t) {
	return (int)(rnd() % (t - s + 1)) + s;
}

void inil()
{
	int i, j, k;
	img.setsize(width, height);

	for (i = 0; i < 10; i++) {
		char xxx[99];
		sprintf(xxx, "numbers/%d.png", i);
		number[i].Load(xxx);
		//number[i].set_transparency_color(255, 255, 255, 0);
		for (int j = 0; j < number[i].h; j++) {
			for (int k = 0; k < number[i].w; k++) {
				int id = (j * number[i].w + k);
				int z = number[i].data[id * 4 + 0];
				number[i].data[id * 4 + 0] = 0;
				number[i].data[id * 4 + 1] = 0;
				number[i].data[id * 4 + 2] = 0;
				number[i].data[id * 4 + 3] = 255 - z;
			}
		}
	}
	imagejojic.Load("jojic.png");
	imagejusagi.Load("jusagi.png");
	imagejusagi.set_transparency_color(100, 0, 0, 0);
}
int a[4][4] = {
	{2,2,2,1},
	{2,2,1,3},
	{2,1,3,3},
	{1,3,3,3},
};
int b[4][4] = {
	{4,4,4,1},
	{4,4,1,3},
	{4,1,3,3},
	{1,3,3,3},
};
int n = 4;
int m = 4;
int si = 1;
int sj = 0;
lf color[4][4] = {
	{0.8, 0.8, 0.7},
	{200.0 / 255.0, 58.0 / 255.0, 142.0 / 255.0},
	{49.0 / 255.0, 194.0 / 255.0, 238.0 / 255.0},
	{229.0 / 255.0, 159.0 / 255.0, 1.0 / 255.0},
};

void draw_before() {
	int i, j, k;
	img.clean(1.0, 1.0, 1.0);
	lf dx = (width - padding * 2) / m;
	lf dy = (height - padding * 2) / n;
	lf ndx = dx * numscale;
	lf ndy = dy * numscale;
	lf nsx = (dx - ndx) * 0.5;
	lf nsy = (dy - ndy) * 0.5;
	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			lf cx = padding + dx * j;
			lf cy = padding + dy * i;
			k = a[i][j] - 1;
			//change jojic color
			Image jojic = jojics[i][j];
			for (int ii = 0; ii < jojic.h; ii++) {
				for (int jj = 0; jj < jojic.w; jj++) {
					int id = ii * jojic.w + jj;
					for (int kk = 0; kk < 3; kk++) {
						jojic.data[id * 4 + kk] = jojic.data[id * 4 + kk] * color[k][kk];
					}
				}
			}
			img.draw_image(cx, cy, cx + dx, cy + dy, jojic);
			img.draw_image(cx + nsx, cy + nsy, cx + nsx + ndx, cy + nsy + ndy, number[k + 1]);
		}
	}
}

void draw_after() {
	int i, j, k;
	img.clean(1.0, 1.0, 1.0);
	lf dx = (width - padding * 2) / m;
	lf dy = (height - padding * 2) / n;
	lf ndx = dx * numscale;
	lf ndy = dy * numscale;
	lf nsx = (dx - ndx) * 0.5;
	lf nsy = (dy - ndy) * 0.5;
	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			lf cx = padding + dx * j;
			lf cy = padding + dy * i;
			k = b[i][j] - 1;
			//change jojic color
			Image jojic = jojics[i][j];
			for (int ii = 0; ii < jojic.h; ii++) {
				for (int jj = 0; jj < jojic.w; jj++) {
					int id = ii * jojic.w + jj;
					for (int kk = 0; kk < 3; kk++) {
						jojic.data[id * 4 + kk] = jojic.data[id * 4 + kk] * color[k][kk];
					}
				}
			}
			img.draw_image(cx, cy, cx + dx, cy + dy, jojic);
			img.draw_image(cx + nsx, cy + nsy, cx + nsx + ndx, cy + nsy + ndy, number[k + 1]);
		}
	}
}

void draw_inject() {
	int i, j, k;
	img.clean(1.0, 1.0, 1.0);
	lf dx = (width - padding * 2) / m;
	lf dy = (height - padding * 2) / n;
	lf ndx = dx * numscale;
	lf ndy = dy * numscale;
	lf nsx = (dx - ndx) * 0.5;
	lf nsy = (dy - ndy) * 0.5;
	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			lf cx = padding + dx * j;
			lf cy = padding + dy * i;
			k = a[i][j] - 1;
			//change jojic color
			Image jojic = jojics[i][j];
			for (int ii = 0; ii < jojic.h; ii++) {
				for (int jj = 0; jj < jojic.w; jj++) {
					int id = ii * jojic.w + jj;
					for (int kk = 0; kk < 3; kk++) {
						jojic.data[id * 4 + kk] = jojic.data[id * 4 + kk] * color[k][kk];
					}
					if (i == si && j == sj) {
						if ((ii + jj) % 10 <= 4) {
							int zz = jojic.data[id * 4 + 0];
							zz *= 1.5;
							if (zz > 255)zz = 255;
							jojic.data[id * 4 + 0] = zz;
						}
					}
				}
			}
			img.draw_image(cx, cy, cx + dx, cy + dy, jojic);
			img.draw_image(cx + nsx, cy + nsy, cx + nsx + ndx, cy + nsy + ndy, number[k + 1]);
		}
	}
	int ddx[4] = { 0,1,0,-1 };
	int ddy[4] = { 1,0,-1,0 };
	int ddxz[4] = { 1, 1, 0, 0 };
	int ddxw[4] = { 1, 0, 0, 1 };
	int ddyz[4] = { 0, 1, 1, 0 };
	int ddyw[4] = { 1, 1, 0, 0 };
	i = si;
	{
		j = sj;
		{
			lf cx = padding + dx * j;
			lf cy = padding + dy * i;
			{
				for (k = 0; k < 4; k++) {
					int ti = i + ddx[k];
					int tj = j + ddy[k];
					img.draw_line(cx + dx * ddxz[k], cy + dy * ddyz[k], cx + dx * ddxw[k], cy + dy * ddyw[k], min(dx, dy) * border_scale, 0.5, 0.1, 0.1);
				}
			}
		}
	}
	i = si;
	{
		j = sj;
		{
			lf cx = padding + dx * j;
			lf cy = padding + dy * i;
			{
				for (k = 0; k < 4; k++) {
					int ti = i + ddx[k];
					int tj = j + ddy[k];
					img.draw_line(cx + dx * ddxz[k], cy + dy * ddyz[k], cx + dx * ddxw[k], cy + dy * ddyw[k], min(dx, dy) * border_scale * 0.5, 1.0, 0.2, 0.2);
				}
			}
		}
	}

	// draw jusagi
	{
		lf cx = padding + dx * sj;
		lf cy = padding + dy * si;
		img.draw_image(cx + dx * 0.5, cy - dy * 0.5, cx + dx * 1.5, cy + dy * 0.5, imagejusagi);
	}
}

void draw_spread() {
	int i, j, k;
	img.clean(1.0, 1.0, 1.0);
	lf dx = (width - padding * 2) / m;
	lf dy = (height - padding * 2) / n;
	lf ndx = dx * numscale;
	lf ndy = dy * numscale;
	lf nsx = (dx - ndx) * 0.5;
	lf nsy = (dy - ndy) * 0.5;
	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			lf cx = padding + dx * j;
			lf cy = padding + dy * i;
			k = a[i][j] - 1;
			//change jojic color
			Image jojic = jojics[i][j];
			for (int ii = 0; ii < jojic.h; ii++) {
				for (int jj = 0; jj < jojic.w; jj++) {
					int id = ii * jojic.w + jj;
					for (int kk = 0; kk < 3; kk++) {
						jojic.data[id * 4 + kk] = jojic.data[id * 4 + kk] * color[k][kk];
					}
					if (k == a[si][sj] - 1) {
						if ((ii + jj) % 10 <= 4) {
							int zz = jojic.data[id * 4 + 0];
							zz *= 1.5;
							if (zz > 255)zz = 255;
							jojic.data[id * 4 + 0] = zz;
						}
					}
				}
			}
			img.draw_image(cx, cy, cx + dx, cy + dy, jojic);
			img.draw_image(cx + nsx, cy + nsy, cx + nsx + ndx, cy + nsy + ndy, number[k + 1]);
		}
	}
	int ddx[4] = { 0,1,0,-1 };
	int ddy[4] = { 1,0,-1,0 };
	int ddxz[4] = { 1, 1, 0, 0 };
	int ddxw[4] = { 1, 0, 0, 1 };
	int ddyz[4] = { 0, 1, 1, 0 };
	int ddyw[4] = { 1, 1, 0, 0 };
	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			lf cx = padding + dx * j;
			lf cy = padding + dy * i;
			if (a[i][j] == a[si][sj]) {
				for (k = 0; k < 4; k++) {
					int ti = i + ddx[k];
					int tj = j + ddy[k];
					if (ti >= 0 && ti < n && tj >= 0 && tj < m && a[ti][tj] == a[si][sj]) continue;

					img.draw_line(cx + dx * ddxz[k], cy + dy * ddyz[k], cx + dx * ddxw[k], cy + dy * ddyw[k], min(dx, dy) * border_scale, 0.5, 0.1, 0.1);
				}
			}
		}
	}

	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			lf cx = padding + dx * j;
			lf cy = padding + dy * i;
			if (a[i][j] == a[si][sj]) {
				for (k = 0; k < 4; k++) {
					int ti = i + ddx[k];
					int tj = j + ddy[k];
					if (ti >= 0 && ti < n && tj >= 0 && tj < m && a[ti][tj] == a[si][sj]) continue;
					img.draw_line(cx + dx * ddxz[k], cy + dy * ddyz[k], cx + dx * ddxw[k], cy + dy * ddyw[k], min(dx, dy) * border_scale * 0.5, 1.0, 0.2, 0.2);
				}
			}
		}
	}
}

void build_jojic() {
	int i, j, k;
	int n = 100;
	vector<pair<vec2, vec2>> v(n);
	int h = imagejojic.h;
	int w = imagejojic.w;
	for (int ii = 0; ii < 16; ii++) {
		Image jojic(w, h);
		jojic.draw_image(0, 0, w, h, imagejojic);
		for (k = 0; k < n; k++) {
			v[k].first.x = nextint(0, w);
			v[k].first.y = nextint(0, h);
			v[k].second.x = nextint(1, w) / (lf)w;
			v[k].second.y = nextint(1, h) / (lf)h;
			vec2 d;
			d.x = nextint(1, 100) / 100.0;
			d.y = nextint(1, 100) / 100.0;
			d.normalize();
			//for (int i = v[k].first.y - 2; i <= v[k].first.y + 2; i++) {
				//for (int j = v[k].first.x - 2; j <= v[k].first.y + 2; j++) {
			for (int i = 0; i < h; i++) {
				for (int j = 0; j < w; j++) {
					vec2 c = vec2(j - v[k].first.x, i - v[k].first.y);
					lf cx = c * d;
					lf cy = c % d;
					if (cx * cx * v[k].second.x + cy * cy * v[k].second.y <= 1)
					{
						int id = i * w + j;
						for (int k = 0; k < 3; k++) {
							jojic.data[id * 4 + k] *= 0.8;
						}
					}
				}
			}
		}
		jojic.mSamplingMode = SamplingModeType::SAMPLING_3x3;
		for (int k = 0; k < 10; k++) {
			const int vn = 10;
			vec2 v[vn];
			vec2 vd[vn];
			lf vz[vn];
			v[0].x = nextint(0, w);
			v[0].y = nextint(0, h);
			vec2 d;
			d.x = nextint(1, 100) / 100.0;
			d.y = nextint(1, 100) / 100.0;
			d.normalize();
			if (nextint(0, 1) == 0)d.x = -d.x;
			if (nextint(0, 1) == 0)d.y = -d.y;
			for (int l = 0; l < vn - 1; l++) {
				vd[l] = d;
				vz[l] = nextint(50, 100) / 100.0 * 3.0;
				//vz[l] = 5;
				v[l + 1] = v[l] + d * nextint(0, min(w, h)) * 0.1;
				v[l + 1] = v[l] + d * min(w, h) * 0.1;
				lf ang = nextint(-100, 100) / 100.0 * 0.2;
				vec2 dd = vec2(d.x * cos(ang) - d.y * sin(ang), d.x * sin(ang) + d.y * cos(ang));
				d = dd;
			}
			vector<lf> px(vn * 2 - 2);
			vector<lf> py(vn * 2 - 2);
			px[0] = v[0].x;
			py[0] = v[0].y;
			for (int l = 0; l < vn - 1; l++) {
				vec2 d = (vd[l] + vd[l + 1]) * 0.5;
				d.normalize();
				px[l + 1] = v[l + 1].x - d.y * vz[l];
				py[l + 1] = v[l + 1].y + d.x * vz[l];
				px[2 * vn - 2 - l - 1] = v[l + 1].x + d.y * vz[l];
				py[2 * vn - 2 - l - 1] = v[l + 1].y - d.x * vz[l];
			}
			jojic.draw_polygon(vn * 2 - 2, px, py, 0.0, 0.0, 0.0, 0.2);
		}
		jojic.mSamplingMode = SamplingModeType::SAMPLING_CENTER;
		jojic.mAlphaBehavior = AlphaBehaviorType::ONE;
		for (int k = 0; k < 10; k++) {
			jojic.draw_circle(w * 0.5, h * 0.5, w * 0.5 * (k + 1) / 10.0, 1.0, 1.0, 1.0, 0.03);
		}
		jojic.mAlphaBehavior = AlphaBehaviorType::ONE_MINUS_ALPHA;
		jojics[ii/4][ii%4] = jojic;
	}
}
int main() {
	int i, j, k;
	inil();
	build_jojic();
	jojics[0][0].Save("modified_jojic.png");

	draw_before();
	img.Save("00_before_cpcu.png");
	draw_inject();
	img.Save("01_inject_cpcu.png");
	draw_spread();
	img.Save("02_spread_cpcu.png");
	draw_after();
	img.Save("03_after_cpcu.png");
}